package de.accso.flexinale.web;

import de.accso.flexinale.application.FilmService;
import de.accso.flexinale.data.model.Benutzer;
import de.accso.flexinale.data.model.Film;
import de.accso.flexinale.data.model.Vorfuehrung;
import de.accso.flexinale.security.BenutzerDetailsService;
import jakarta.transaction.Transactional;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.server.ResponseStatusException;

import java.util.List;

@Controller
@Transactional
public class FilmWebController {
    @Autowired
    private FilmService filmService;

    @Autowired
    private BenutzerDetailsService benutzerService;

    @GetMapping(value="/filme")
    @PreAuthorize("hasRole('ROLE_BESUCHER')")
    @SuppressWarnings("SameReturnValue")
    public String filme(final Model model) {
        List<Film> filme = filmService.filme();
        model.addAttribute("filme", filme);
        return "filme";
    }

    @GetMapping(value="/film/{id}")
    @PreAuthorize("hasRole('ROLE_BESUCHER')")
    @SuppressWarnings("SameReturnValue")
    public String film(@PathVariable("id") final String id, final Model model) {
        Film film = filmService.film(id);
        if (film == null) {
            throw new ResponseStatusException(HttpStatus.NOT_FOUND, "film %s not available".formatted(id));
        }
        else {
            model.addAttribute("film", film);
            List<Vorfuehrung> vorfuehrungenOfFilm = filmService.vorfuehrungenFuer(id);
            model.addAttribute("vorfuehrungen", vorfuehrungenOfFilm);

            if (!vorfuehrungenOfFilm.isEmpty()) {
                Benutzer benutzerLoggedIn = benutzerService.getLoggedInBenutzer();
                List<String> vorfuehrungenMitUeberlapp =
                        filmService.vorfuehrungenMitUeberlapp(vorfuehrungenOfFilm, benutzerLoggedIn);
                model.addAttribute("vorfuehrungenMitUeberlapp", vorfuehrungenMitUeberlapp);
                List<String> vorfuehrungenMitTicket =
                        filmService.vorfuehrungenFuerDieDerBenutzerEinTicketHat(vorfuehrungenOfFilm, benutzerLoggedIn);
                model.addAttribute("vorfuehrungenMitTicket", vorfuehrungenMitTicket);
            }
        }

        return "film";
    }
}
